var http = require("http");

exports.command = function(desiredCapabilities, callback) 
{
	
	var self = this;
	
	var instanceDesiredCapabilities = self.defaultDesiredCapabilities; 
	
//	console.log("INIT ", typeof desiredCapabilities, desiredCapabilities)
	if (typeof desiredCapabilities == "function") 
	{
		callback = desiredCapabilities;
		desiredCapabilities = null;
	}
	else
	{
		instanceDesiredCapabilities = self.extend(instanceDesiredCapabilities, desiredCapabilities);
		
		if (desiredCapabilities.sessionId)
		{
			self.sessionId = desiredCapabilities.sessionId;
		}
	}
	
	var startOptions = self.createOptions({});

	var request = this.createRequest(startOptions, 
		function(response) 
		{
			var data = "";
			
			response.on('data', function(chunk) { data += chunk.toString(); });
			response.on('end', 
				function() 
				{
					if (response.headers.location == undefined) 
					{
						console.log("NO DESIRED ENV", data);
						return;
					}
					
					var locationList = response.headers.location.split("/");
					self.sessionId = locationList[locationList.length - 1];
					
					
					
					if (callback) 
					{ 
						callback(self.sessionId);
					}
				}
			);
		}
	);
	
	request.write(JSON.stringify({desiredCapabilities: instanceDesiredCapabilities}));
	request.end();
	
};